#include lerp.lua

function init()
	if not HasKey("savegame.mod.bladetype") then
		SetInt("savegame.mod.bladetype", "4")
	end
	if not HasKey("savegame.mod.launchertype") then
		SetInt("savegame.mod.launchertype", "1")
	end
	if not HasKey("savegame.mod.cutaccuracy") then
		SetInt("savegame.mod.cutaccuracy", "4")
	end
    if GetInt("savegame.mod.cutaccuracy") > 9 or GetInt("savegame.mod.cutaccuracy") < 0 then SetInt("savegame.mod.cutaccuracy", "3") end
    if not HasKey("savegame.mod.volume") then
        SetFloat("savegame.mod.volume", 2)  --It's easier if I keep it 0 to 2, I convert it anyways in the main code
    elseif GetFloat("savegame.mod.volume") > 2 or GetFloat("savegame.mod.volume") < 0 then
        SetFloat("savegame.mod.volume", 2) -- in case of a freak accident putting the value too high or low
    end

    expandbladeselect = false
    expandlauncherselect = false

    dropdownvertoffset = 60
    hoverblade = false
    hoverlauncher = false
    hovernumb = GetInt("savegame.mod.bladetype")
    hovernuml = GetInt("savegame.mod.launchertype")
    lasthovernumb = GetInt("savegame.mod.bladetype")
    lasthovernuml = GetInt("savegame.mod.launchertype")
    cachedlastimgb =  GetInt("savegame.mod.bladetype")
    cachedlastimgl =  GetInt("savegame.mod.launchertype")
    firsthoverb = true
    firsthoverl = true

    volume = GetFloat("savegame.mod.volume")

    clickedtimer = 0
end

function draw(dt)
    UiPush()
    	UiTranslate(UiCenter(), 100)
        
        UiPush()
            UiAlign("center middle")
    		UiFont("bold.ttf", 80)
    		UiText("Blade Launcher")
        UiPop()

        UiTranslate(0,350)
    
        UiPush()
            UiAlign("center middle")
            UiFont("bold.ttf", 40)
            UiColor(1,1,0.6,1)
            UiText("Sawblade Cutting Accuracy")
    
            UiTranslate(0,40)
    
            UiColor(1,1,1,1)
            UiRect(200, 5)
            UiTranslate(-11,0)
            UiRect(3, 13)
            UiTranslate(11,0)
    
            UiColor(0.9,0.9,0.9,1)
    
            UiTranslate(0,15)
            UiImageBox("ui/common/box-outline-6.png", 300, 60, 10, 10)
            UiTranslate(0,-15)
    
            cutaccuracy = (GetFloat("savegame.mod.cutaccuracy")*22.2222-100)-1
            cutaccuracy, cutaccuracydone = UiSlider("ui/common/dot.png", "x", round(cutaccuracy, 1), -100, 100)
            cutaccuracy = round(cutaccuracy, 1)
            SetFloat("savegame.mod.cutaccuracy", round((cutaccuracy+100)/22.2222, 1))
    
            UiTranslate((round((cutaccuracy/22.2222)-0.5, 1)*22.2222)+5, 0)
            local clickingon = InputPressed("lmb") and UiIsMouseInRect(25, 25) and not (expandlauncherselect or expandbladeselect)
            if InputDown("lmb") and clickingon then 
                UiTranslate(-17, 0)
                dragging = true
            elseif InputDown("lmb") and dragging then
                UiTranslate(-17, 0)
            else
                UiTranslate((-round((cutaccuracy/22.2222)+0.5, 1)*22.2222)-5, 0)
                dragging = false
            end
    
            UiTranslate(22,25)
            UiColor(1,1,0.7,1)
    
            UiFont("bold.ttf", 30)
            local textfull = round((cutaccuracy+100)/22.2222, 1)+1
            UiText(textfull)
            
            if InputDown("lmb") and (clickingon or dragging) and not (expandlauncherselect or expandbladeselect) then 
                UiTranslate((-round((cutaccuracy/22.2222)+0.5, 1)*22.2222)+12, 40)
            else
                UiTranslate(0, 40)
            end
            UiFont("bold.ttf", 45)
            UiText(round((cutaccuracy+100)/22.2222, 1)+1)
    
            UiTranslate(0, 30)
            UiColor(1,1,1,1)
            UiFont("bold.ttf", 30)
            UiText("cuts per rotation")
            UiTranslate(0, 30)
            UiText("(higher number means more accuracy but can increase lag)")
        UiPop()

        UiTranslate(0,225)

        UiPush()
            UiAlign("center middle")
            UiFont("bold.ttf", 40)
            UiColor(1,1,0.6,1)
            UiText("Volume")

            UiTranslate(0,40)

            UiColor(1,1,1,1)
            UiRect(200, 5)
            UiTranslate(100,0)
            UiRect(3, 13)
            UiTranslate(-100,0)

            UiColor(0.9,0.9,0.9,1)

            UiTranslate(0,15)
            UiImageBox("ui/common/box-outline-6.png", 300, 60, 10, 10)
            UiTranslate(0,-15)
    
            volume = GetFloat("savegame.mod.volume")*100-100
            volume, volumedone = UiSlider("ui/common/dot.png", "x", round(volume, 0.05), -100, 100)
            volume = round(volume, 0.05)
            SetFloat("savegame.mod.volume", round((volume+100)/100, 0.05))

            UiTranslate(round(volume/100, 0.05)*100, 0)
            local clickingon2 = InputPressed("lmb") and UiIsMouseInRect(25, 25)
            if InputDown("lmb") and clickingon2 then 
                UiTranslate(0, 0)
                dragging2 = true
            elseif InputDown("lmb") and dragging2 then
                UiTranslate(0, 0)
            else
                UiTranslate(-round(volume/100, 0.05)*100, 0)
                dragging2 = false
            end

            UiTranslate(0,25)
            UiColor(1,1,0.7,1)

            UiFont("bold.ttf", 30)
            if round((volume+100)/200, 0.05) ~= round((volume+100)/200, 1) and round((volume+100)/200, 0.05) == round((volume+100)/200, 0.1) then text = "0" else text = "" end
            local textfull = round((volume+100)/200, 0.05)..text.."x"
            UiText(textfull)
            
            if InputDown("lmb") and (clickingon2 or dragging2) then 
                UiTranslate(-round(volume/100, 0.05)*100, 40)
            else
                UiTranslate(0, 40)
            end
            UiFont("bold.ttf", 45)
            UiText((round((volume+100)/200, 0.05)*100).."%")

            UiTranslate(0, 30)
            UiColor(1,1,1,1)
            UiFont("bold.ttf", 30)
        UiPop()

        UiTranslate(0,-425)

        UiPush() --blade dropdown
            UiTranslate(-200,-25)

            UiAlign("center top")
            UiFont("bold.ttf", 50)
            UiColor(1,1,0.6,1)
            UiText("Blade Style")

            UiTranslate(0,85)

            UiAlign("center middle")

            UiColor(1,1,1,1)
            UiFont("bold.ttf", 40)
            UiButtonHoverColor(1, 1, 1, 2)
            UiButtonPressColor(1,1,1,0.8)

            bladename = {"Red Sharp", "Green Sharp", "Blue Sharp", "Red Rounded", "Green Rounded", "Blue Rounded"}

            if UiIsMouseInRect(300, 60) and InputDown("lmb") then UiTranslate(2,2) UiColor(1,1,1,0.8) boffset2 = true else UiTranslate(0,0) UiColor(1,1,1,1) boffset2 = false end
            UiImageBox("ui/common/box-outline-6.png", 300, 60, 12, 12)
            if boffset2 == true then UiTranslate(-2,-2) else UiTranslate(0,0) end

            UiColor(1,1,1,0)
            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0)
            if not expandbladeselect then 
                if UiTextButton("a", 300, 60) and GetTime() > clickedtimer + 0.1 then
                    expandbladeselect = true
                    clickedtimer = GetTime()
                end
            else
                if UiTextButton("b", 300, 60) and GetTime() > clickedtimer + 0.1 then
                    expandbladeselect = false
                    clickedtimer = GetTime()
                end
            end
            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
            if UiIsMouseInRect(300, 60) and InputDown("lmb") then UiTranslate(-18,2) UiColor(1,1,1,0.8) boffset = true else UiTranslate(-20,0) UiColor(1,1,1,1) boffset = false end
            UiText(bladename[GetInt("savegame.mod.bladetype")])
            UiTranslate(140,2)
            if expandbladeselect then UiImage("MOD/ui/arrow-up.png") else UiImage("MOD/ui/arrow-down.png") end
            UiTranslate(-140,-2)
            if boffset == true then UiTranslate(18,-2) else UiTranslate(20,0) end
            UiColor(1,1,1,1)

            if expandbladeselect then
                UiPush()
                    if hovernumb ~= GetInt("savegame.mod.bladetype") and firsthoverb then lasthovernumb = 0 firsthoverb = false end
                    UiTranslate(0,dropdownvertoffset+20)
                    UiAlign("center top")
                    UiColor(0,0,0,1)
                    UiTranslate(0,-30)
                    UiRect(300, 360)
                    UiColor(1,1,1,1)
                    UiTranslate(0,30)
                    UiAlign("center middle")

                    if UiTextButton(bladename[1], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "1")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 1 then lasthovernumb = hovernumb end
                        hovernumb = 1
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(bladename[2], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "2")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 2 then lasthovernumb = hovernumb end
                        hovernumb = 2
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(bladename[3], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "3")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 3 then lasthovernumb = hovernumb end
                        hovernumb = 3
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(bladename[4], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "4")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 4 then lasthovernumb = hovernumb end
                        hovernumb = 4
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(bladename[5], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "5")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 5 then lasthovernumb = hovernumb end
                        hovernumb = 5
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(bladename[6], 300, 60) then
                        expandbladeselect = false
                        SetInt("savegame.mod.bladetype", "6")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverblade = true
                        if hovernumb ~= 6 then lasthovernumb = hovernumb end
                        hovernumb = 6
                    end

                    UiAlign("center bottom")
                    UiTranslate(0,31)
                    if not UiIsMouseInRect(302,362) then
                        hoverblade = false
                        if hovernumb ~= GetInt("savegame.mod.bladetype") then lasthovernumb = hovernumb end
                        hovernumb = GetInt("savegame.mod.bladetype")
                        if InputPressed("lmb") then
                            expandbladeselect = false
                        end
                    end
                UiPop()
            end

            if lasthovernumb ~= cachedlastimgb then
                cachedlastimgb = lasthovernumb
                ImageFadeIn(true)
            end

            UiTranslate(-160,100)
            UiAlign("right middle")

            if firsthoverb then UiColor(1,1,1,1) else UiColor(1,1,1,ImageFadeIn()) end

            bladeimagename = {"blade_red_t.png", "blade_green_t.png", "blade_blue_t.png", "blade2_red_t.png", "blade2_green_t.png", "blade2_blue_t.png"}
            if hoverblade then UiImage("MOD/previews/"..bladeimagename[hovernumb]) else UiImage("MOD/previews/"..bladeimagename[GetInt("savegame.mod.bladetype")]) end
        UiPop()

        UiPush() --launcher dropdown
            UiTranslate(200,-25)

            UiAlign("center top")
            UiFont("bold.ttf", 50)
            UiColor(1,1,0.6,1)
            UiText("Launcher Color")

            UiTranslate(0,85)

            UiAlign("center middle")

            UiColor(1,1,1,1)
            UiFont("bold.ttf", 40)
            UiButtonHoverColor(1, 1, 1, 2)

            launchername = {"Red", "Green", "Blue"}

            if UiIsMouseInRect(300, 60) and InputDown("lmb") then UiTranslate(2,2) UiColor(1,1,1,0.8) loffset2 = true else UiTranslate(0,0) UiColor(1,1,1,1) loffset2 = false end
            UiImageBox("ui/common/box-outline-6.png", 160, 60, 12, 12)
            if loffset2 == true then UiTranslate(-2,-2) else UiTranslate(0,0) end
    
            UiColor(1,1,1,0)
            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0)
            if not expandlauncherselect then 
                if UiTextButton("a", 160, 60) and GetTime() > clickedtimer + 0.1 then
                    expandlauncherselect = true
                    clickedtimer = GetTime()
                end
            else
                if UiTextButton("b", 160, 60) and GetTime() > clickedtimer + 0.1 then
                    expandlauncherselect = false
                    clickedtimer = GetTime()
                end
            end
            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
            if UiIsMouseInRect(160, 60) and InputDown("lmb") then UiTranslate(-18,2) UiColor(1,1,1,0.8) loffset = true else UiTranslate(-20,0) UiColor(1,1,1,1) loffset = false end
            UiText(launchername[GetInt("savegame.mod.launchertype")])
            UiTranslate(70,2)
            if expandlauncherselect then UiImage("MOD/ui/arrow-up.png") else UiImage("MOD/ui/arrow-down.png") end
            UiTranslate(-70,-2)
            if loffset == true then UiTranslate(18,-2) else UiTranslate(20,0) end
            UiColor(1,1,1,1)

            if expandlauncherselect then
                UiPush()
                    if hovernuml ~= GetInt("savegame.mod.launchertype") and firsthoverl then lasthovernuml = 0 firsthoverl = false end
                    UiTranslate(0,dropdownvertoffset+20)
                    UiAlign("center top")
                    UiColor(0,0,0,1)
                    UiTranslate(0,-30)
                    UiRect(160, 180)
                    UiColor(1,1,1,1)
                    UiTranslate(0,30)
                    UiAlign("center middle")

                    if UiTextButton(launchername[1], 160, 60) then
                        expandlauncherselect = false
                        SetInt("savegame.mod.launchertype", "1")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverlauncher = true
                        if hovernuml ~= 1 then lasthovernuml = hovernuml end
                        hovernuml = 1
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(launchername[2], 160, 60) then
                        expandlauncherselect = false
                        SetInt("savegame.mod.launchertype", "2")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverlauncher = true
                        if hovernuml ~= 2 then lasthovernuml = hovernuml end
                        hovernuml = 2
                    end
                    UiTranslate(0,dropdownvertoffset)
                    
                    if UiTextButton(launchername[3], 160, 60) then
                        expandlauncherselect = false
                        SetInt("savegame.mod.launchertype", "3")
                    end
                    if UiIsMouseInRect(300,60) then
                        hoverlauncher = true
                        if hovernuml ~= 3 then lasthovernuml = hovernuml end
                        hovernuml = 3
                    end

                    UiAlign("center bottom")
                    UiTranslate(0,31)
                    if not UiIsMouseInRect(162,182) then
                        hoverlauncher = false
                        if hovernuml ~= GetInt("savegame.mod.launchertype") then lasthovernuml = hovernuml end
                        hovernuml = GetInt("savegame.mod.launchertype")
                        if InputPressed("lmb") then
                            expandlauncherselect = false
                        end
                    end
                UiPop()
            end

            if lasthovernuml ~= cachedlastimgl then
                cachedlastimgl = lasthovernuml
                ImageFadeIn2(true)
            end

            UiTranslate(160,100)
            UiAlign("left middle")

            if firsthoverl then UiColor(1,1,1,1) else UiColor(1,1,1,ImageFadeIn2()) end

            launcherimagename = {"launcher_red_t.png", "launcher_green_t.png", "launcher_blue_t.png"}
            if hoverlauncher then UiImage("MOD/previews/"..launcherimagename[hovernuml]) else UiImage("MOD/previews/"..launcherimagename[GetInt("savegame.mod.launchertype")]) end
        UiPop()

        UiTranslate(0, 625)

        UiPush()
            multiblade = GetBool("savegame.mod.multiblade")
            UiAlign("center middle")
    
            UiColor(1,1,1,1)
            UiFont("bold.ttf", 60)
            UiButtonHoverColor(0.8, 0.8, 0.8, 0.8)
    
            if multiblade then multibladetext = "[EXPERIMENTAL] Multiblade Mode: On" else multibladetext = "[EXPERIMENTAL] Multiblade Mode: Off" end
            if multiblade then
                UiTextOutline(0,0.7,0,0.8,0.9)
            else
                UiTextOutline(0.7,0,0,0.8,0.9)
            end
            if UiTextButton(multibladetext) then
                if multiblade then
                    SetBool("savegame.mod.multiblade", false)
                else
                    SetBool("savegame.mod.multiblade", true)
                end
            end
            UiTranslate(0,2)
            local w,h = UiGetTextSize(multibladetext)
            UiImageBox("ui/common/box-outline-6.png", w+30, 80, 10, 10)
        UiPop()
    UiPop()

    UiPush()
        UiAlign("center middle")
        UiTranslate(UiCenter(),UiHeight() - 80)

        UiColor(1,1,1,0.7)
        UiFont("bold.ttf", 32)
        UiButtonHoverColor(1, 1, 1, 2)

        UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)

        if UiTextButton("CLOSE", 200, 60) then
			Menu()
		end
    UiPop()
end

function round(x, d)
	d = d or 1
	return math.floor(x / d + 0.5) * d
end